#!/usr/bin/perl
#
#  GruopCGI-Light
#    abook.cgi ver.2.00.00.0203
#
#  Copyright(c) 1999-2000 Active Network Design, Ltd. All right reserved.
#    support@and.ne.jp
#    http://www.and.ne.jp
#
#    եȥѵ˴ŤƤѤ
#===================================================================
# Permission granted to use and modify this library so long as the
# copyright above is maintained, for the purpose of your private use.
# ΥեȥѤѤ뤳ȤǤޤâѤ
# ͤȤΤߤλѤŪȤ嵭ɽäʤ
# Ȥޤ
#===================================================================
#
require './auth-lib.pl';
require './arraydb.pl';
require './cgi-lib.pl';

## authentication --
$uid = &Auth;
if (!$uid) { exit; }

use makemenu;

$sys_db = &HashDB::Retrieve ('sys');
$rh_cssfile_config = $sys_db->GetHash('CSSFILE_CONFIG');
$cssfile = "$rh_cssfile_config->{'CURRENT'}";

$ADD_HTM = 'template/abook_add.htm';
$EDIT_HTM = 'template/abook_edit.htm';
$LIST_HTM = 'template/abook_list.htm';
$CONF_HTM = 'template/abook_conf.htm';
$UP_ARROW = 'template/up.gif';
$DOWN_ARROW = 'template/down.gif';

($SEC, $MIN, $HOUR, $TODAY, $THIS_MONTH, $THIS_YEAR, $WDAY) = localtime(time);
$THIS_MONTH++;

$day_of_week = ("<FONT color=#ff0000></FONT>", "", "", "", "", "", "")[$WDAY];


## browser parse --
ReadParse(*form);
$mode = $form{'mode'};
$search = $form{'search'};
$show = $form{'show'}; ## SHOW or HIDE
$direction = $form{'dir'}; ## UP or DOWN
$row = $form{'r'};
$col = $form{'c'};

@COL_LABEL = ("̾ ", "դ꤬", "̾", " ", " ", "ե", "  ",
	" 1", " 2", " ", " FAX ", " ", "E-Mail", "ۡڡ", " ", "¾");

## main --
$data_db = ArrayDB->Retrieve ('abook');
$ra_LIST = $data_db->GetArray ('LIST1');
$users = @{$ra_LIST};
@row_order = (0 .. $users);

$ra_CONFIG = $data_db->GetArray ('CONFIG');

my @conf;
my $r = 0;
while (@conf = @{$ra_CONFIG->[$r]}) {
	my $conf_name = shift (@conf);
	if ($conf_name eq "COL_ORDER") { @col_order = @conf; }
	if ($conf_name eq "COL_LABEL_ORDER") { @col_label_order= @conf; }
	if ($conf_name eq "COL_LABEL_SHOW") { @col_label_show= @conf; }
	if ($conf_name eq "SHOW_ALL") { ($show_all) = @conf; }
	$r ++;
}

if ($mode eq "add") { &add; }
elsif ($mode eq "edit") { &edit; }
elsif ($mode eq "clear") { &clear; }
elsif ($mode eq "update") { &update; }
elsif ($mode eq "remove") { &remove; }
elsif ($mode eq "conf") { &conf; }
else { &list; }

sub list {
	my ($ra_row_order, $ra_hit_col);
	if ($search ne "" && ref ($ra_LIST)) {
		($ra_LIST, $ra_row_order, $ra_hit_col) = $ra_LIST->Search ($search);
		@row_order = @{$ra_row_order};
	}
	if ($direction && ref ($ra_LIST)) {
		($ra_LIST, $ra_row_order) = $ra_LIST->Sort ($col, $type, $direction);
		@row_order = @row_order[@{$ra_row_order}];
	}
	my @row = @{$ra_LIST};

	my $r = 0;
	foreach (@row) {
		my @col = @{$_};
		if (!$col[16] && !$show_all) { $_ = ""; $r ++; next; }

		@col = @col[@col_order];
		my $c = 0;
		foreach (@col) {
			if ($_ eq "") { $_ = " - "; }
			if ($c == 0) { $_ = "<A HREF=\"abook.cgi?mode=edit&r=$row_order[$r]\">$_</A>"; }
			elsif (/\w+@\w+/) { $_ = "<A HREF=MAILTO:$_ style=text-decoration:none>$_</A>"; }
			elsif (/\w+\.\w+/) { $_ = "<A HREF=\"http://$_\">http://$_</A>"; }

			$_ = "<TD nowrap><FONT class=nFont>$_</FONT></TD>";

			$c ++;
        	}
		if ($search ne "") {
			my $hit_col = @{$_}[$ra_hit_col->[$r]];
			$hit_col =~ s/$search/<FONT color=\"red\">$search<\/FONT>/;
			unshift (@col, "<TD nowrap><FONT class=nFont>$hit_col</FONT></TD>");
		}

		if ($r % 2) { unshift (@col, "<TR class=\"line2\" align=\"center\">\n"); }
		else { unshift (@col, "<TR class=\"line3\" align=\"center\">\n"); }
		push (@col, "</TR>\n");

		$_ = join ("", @col);
		$r ++;

	}

	## table header --
	@header = @COL_LABEL[@col_order];
	my $c = 0;
	foreach (@header) {
		my $dir = 'UP';
		if ($col_order[$c] == $col && $direction eq 'UP') { $_ = "$_ "; $dir = 'DOWN'; }
		elsif ($col_order[$c] == $col && $direction eq 'DOWN') { $_ = "$_ "; $dir = 'UP'; }

		if ($search ne "") {
			my @col = ("<TD>",
				"<FORM action=\"abook.cgi\" method=\"GET\">",
				"<INPUT type=\"hidden\" name=\"search\" value=\"$search\">",
				"<INPUT type=\"hidden\" name=\"c\" value=\"$col_order[$c]\">",
				"<INPUT type=\"hidden\" name=\"dir\" value=\"$dir\">",
				"<INPUT type=\"submit\" value=\"$_\">",
				"</TD>",
				"</FORM>");
			$_ = join ("", @col);
		} else {
			my @col = ("<TD>",
				"<FORM action=\"abook.cgi\" method=\"GET\">",
				"<INPUT type=\"hidden\" name=\"c\" value=\"$col_order[$c]\">",
				"<INPUT type=\"hidden\" name=\"dir\" value=\"$dir\">",
				"<INPUT type=\"submit\" value=\"$_\">",
				"</TD>",
				"</FORM>");
			$_ = join ("", @col);
		}
		$c ++;
	}
	if ($search ne "") { unshift (@header, "<TD nowrap><FONT class=tFont></FONT></TD>"); }
	unshift (@header, "<TR align=\"center\" class=\"menu1\">");
	push (@header, "</TR>\n");

	unshift (@row, @header);

	## table tags --
	unshift (@row, "<TABLE border=0 width=100% cellpadding=0 cellspacing=0 class=cBorder><TBODY><TR><TD>\n",
			"<TABLE border=\"0\" width=\"100%\" cellpadding=\"5\" cellspacing=1><TBODY>\n");
	push (@row, "</TBODY></TABLE>\n",
			"</TD></TR></TBODY></TABLE>\n");

	$VAR{'SEARCH_VALUE'} = "$search";
	$VAR{'NAME_LIST'} = "@row";

	
	print "Pragma: no-cache\n";
	print "Content-type: text/html\n\n";
	$header = new makemenu();
	$header->make_header("",$cssfile);
	print "$header->{'items'}";
	$a = new makemenu();
	$a->put_item("[]","abook.cgi",pFont);
	$a->put_item("[Ͽ]","abook.cgi?mode=add",tFont);
	$a->put_item("[]","abook.cgi?mode=conf",tFont);
	$a->put_item("[ȥå]","./index.cgi",tFont);
	$a->put_month_day("$THIS_MONTH","$TODAY","$day_of_week");
	$a->{'items'} = "<TABLE border=\"0\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><TBODY><TR>$a->{'items'}</TR></TBODY></TABLE>";
	$a->{'items'} = "<TD width=\"98%\" class=cMenu>$a->{'items'}</td>";
	$a->put_watch;
	$a->put_help("makehelp.cgi?helpfile=habook");

	$a->make_table("100%","0","0","0","");
	$a->{'items'} = "<td>$a->{'items'}</td>";
	$a->make_table("100%","0","1","0","cBorder","<FORM name=\"disp\">");
	print "$a->{'items'}<p>";
	&parse_template("$LIST_HTM", *STDOUT);

	exit;
}
sub conf {
	my $flag = 0;
	if ($row ne "" && ($show || $direction)) {
		if ($show eq 'SHOW') { $col_label_show[$row] = '1'; }
		if ($show eq 'HIDE') { $col_label_show[$row] = '0'; }
		if ($direction eq 'UP') {
			@col_label_order[($row - 1, $row)] = @col_label_order[($row, $row - 1)];
			@col_label_show[($row - 1, $row)] = @col_label_show[($row, $row - 1)];
		}
		if ($direction eq 'DOWN') {
			@col_label_order[($row, $row + 1)] = @col_label_order[($row + 1, $row)];
			@col_label_show[($row, $row + 1)] = @col_label_show[($row + 1, $row)];
		}
		my @col_order_temp;
		my $c = 0;
		foreach (@col_label_order) {
			if ($col_label_show[$c]) { push (@col_order_temp, $_); }
			$c ++;
		}
		my @col_label_order_temp = @col_label_order;
		my @col_label_show_temp = @col_label_show;
		unshift (@col_label_order_temp, 'COL_LABEL_ORDER');
		unshift (@col_label_show_temp, 'COL_LABEL_SHOW');
		unshift (@col_order_temp, 'COL_ORDER');
		$ra_CONFIG->[0] = \@col_label_order_temp;
		$ra_CONFIG->[1] = \@col_label_show_temp;
		$ra_CONFIG->[2] = \@col_order_temp;

		$flag = 1;
	}
	if (defined ($form{'show_all'})) {
		$show_all = $form{'show_all'};
		$ra_CONFIG->[3] = ['SHOW_ALL', $show_all];
		$flag = 1;
	}
	if ($flag) {
		$data_db->SetArray ('CONFIG', $ra_CONFIG);
		$data_db->Store ();
	}

	my @row = @COL_LABEL[@col_label_order];
	my $last_row = $#row;

	my $r = 0;
	foreach (@row) {
		my $check_box;
		if ($col_label_show[$r]) {
			 $check_box = "<INPUT type=\"checkbox\" name=\"r\" value=\"$r\" onClick=\"location='abook.cgi?mode=conf&r=$r&show=HIDE'\" checked>";
		} else {
			$check_box = "<INPUT type=\"checkbox\" name=\"r\" value=\"$r\" onClick=\"location='abook.cgi?mode=conf&r=$r&show=SHOW'\">";
		}

		my $arrows = "<A href=abook.cgi?mode=conf&r=$r&dir=UP><IMG src=$UP_ARROW border=0 align=top></A> <A href=abook.cgi?mode=conf&r=$r&dir=DOWN><IMG src=$DOWN_ARROW border=0 align=top></A>";
		if ($r == 0) { $arrows = "<A href=abook.cgi?mode=conf&r=$r&dir=DOWN><IMG src=$DOWN_ARROW border=0 align=top></A>"; }
		elsif ($r == $last_row) { $arrows = "<A href=abook.cgi?mode=conf&r=$r&dir=UP><IMG src=$UP_ARROW border=0 align=top></A>"; }
		my @col = ($check_box,
			"<FONT class=nFont size=\"-1\">$_</FONT>",
			$arrows);
		foreach (@col) {
			$_ = "<TD nowrap>$_</TD>";
			$c ++;
        	}
		if ($r % 2) { unshift (@col, "<FORM><TR class=line2 align=\"center\">\n"); }
		else { unshift (@col, "<FORM><TR class=line3 align=\"center\">\n"); }
		push (@col, "</TR></FORM>\n");

		$_ = join ("", @col);
		$r ++;
	}

	## table header --
	unshift (@row, "<TR align=\"center\" class=menu1>\n",
			"<TD width=\"20%\" nowrap><FONT class=tFont>ɽ</FONT></TD>",
			"<TD nowrap><FONT class=tFont>̾</FONT></TD>",
			"<TD width=\"20%\" nowrap><FONT class=tFont>ɽ</FONT></TD>",
			"</TR>");

	## table tags --
	unshift (@row, "<TABLE border=0 width=50% cellpadding=0 cellspacing=0 class=cBorder><TBODY><TR><TD>\n",
			"<TABLE border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=1><TBODY>\n");
	push (@row, "</TBODY></TABLE>\n",
			"</TD></TR></TBODY></TABLE>\n");

	$VAR{'CONF_TABLE'} = "@row";

	if ($show_all) {
		 $show_all = "<INPUT type=\"checkbox\" onClick=\"location='abook.cgi?mode=conf&show_all=0'\" checked>";
	} else {
		$show_all = "<INPUT type=\"checkbox\" onClick=\"location='abook.cgi?mode=conf&show_all=1'\">";
	}
	my @show_all = ("<TABLE border=0 width=50% cellpadding=0 cellspacing=0 class=cBorder><TBODY><TR><TD>\n",
			"<TABLE border=\"0\" width=\"100%\" cellpadding=\"3\" cellspacing=1><TBODY>\n",
			"<TR align=\"center\">\n",
			"<TD class=menu1 nowrap><FONT class=tFont>٤Ƥξɽ</FONT></TD>\n",
			"<TD class=line2 nowrap>$show_all</TD>\n",
			"</TR>\n",
			"</TBODY></TABLE>\n",
			"</TD></TR></TBODY></TABLE>\n");

	$VAR{'SHOW_ALL'} = "@show_all";

	
	print "Pragma: no-cache\n";
	print "Content-type: text/html\n\n";
	$header = new makemenu();
	$header->make_header("",$cssfile);
	print "$header->{'items'}";


	$a = new makemenu();
	$a->put_item("[]","abook.cgi",tFont);
	$a->put_item("[Ͽ]","abook.cgi?mode=add",tFont);
	$a->put_item("[]","abook.cgi?mode=conf",pFont);
	$a->put_item("[ȥå]","./index.cgi",tFont);
	$a->put_month_day("$THIS_MONTH","$TODAY","$day_of_week");
	$a->{'items'} = "<TABLE border=\"0\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><TBODY><TR>$a->{'items'}</TR></TBODY></TABLE>";
	$a->{'items'} = "<TD width=\"98%\" class=cMenu>$a->{'items'}</td>";
	$a->put_watch;
	$a->put_help("makehelp.cgi?helpfile=habook");

	$a->make_table("100%","0","0","0","");
	$a->{'items'} = "<td>$a->{'items'}</td>";
	$a->make_table("100%","0","1",0,cBorder,"<FORM name=\"disp\">");

	print "$a->{'items'}<p>";

	&parse_template("$CONF_HTM", *STDOUT);

	exit;
}
sub add {
	my $last_row = $#{$ra_LIST};
	my $flag = 0;
	foreach (@col_label_order) {
		my $col = $form{"c$_"};
		if ($col ne "") {
			$ra_LIST->[$last_row + 1]->[$_] = $col;
			$flag = 1;
		}
	}
	if ($flag) {
		$ra_LIST->[$last_row + 1]->[16] = 1;
		$data_db->SetArray ('LIST1', $ra_LIST);
		$data_db->Store ();
	}

	
	print "Pragma: no-cache\n";
	print "Content-type: text/html\n\n";
	$header = new makemenu();
	$header->make_header("Ͽ",$cssfile);
	print "$header->{'items'}";


	$a = new makemenu();
	$a->put_item("[]","abook.cgi",tFont);
	$a->put_item("[Ͽ]","abook.cgi?mode=add",pFont);
	$a->put_item("[]","abook.cgi?mode=conf",tFont);
	$a->put_item("[ȥå]","./index.cgi",tFont);
	$a->put_month_day("$THIS_MONTH","$TODAY","$day_of_week");
	$a->{'items'} = "<TABLE border=\"0\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><TBODY><TR>$a->{'items'}</TR></TBODY></TABLE>";
	$a->{'items'} = "<TD width=\"98%\" class=cMenu>$a->{'items'}</td>";
	$a->put_watch;
	$a->put_help("makehelp.cgi?helpfile=habook");

	$a->make_table("100%","0","0","0","");
	$a->{'items'} = "<td>$a->{'items'}</td>";
	$a->make_table("100%","0","1",0,cBorder,"<FORM name=\"disp\">");

	print "$a->{'items'}<p>";
	&parse_template("$ADD_HTM", *STDOUT);

	exit;
}
sub edit {
	my @col = @{$ra_LIST->[$row]};
	my $c = 0;
	foreach (@col) {
		$VAR{"C$c"} = $col[$c];
		$c ++;
	}
	if ($col[16]) { $VAR{'C16_CHECKED'} = "checked"; }
	$VAR{"EDIT_ROW"} = $row;


	print "Pragma: no-cache\n";
	print "Content-type: text/html\n\n";
	
	$header = new makemenu();
	$header->make_header("Ͽѹ",$cssfile);
	print "$header->{'items'}";
	$b = new makemenu();
	$b->push_html("<SCRIPT LANGUAGE=\"JavaScript\">
<!----------
function confirmcrear()
{
if (confirm(\"ϤƤ򥯥ꥢޤǤ\"))
	location=\"abook.cgi?mode=clear&r=$VAR{'EDIT_ROW'}\";
}
function confirmdel()
{
if (confirm(\"ϿޤˤǤ\"))
	location=\"abook.cgi?mode=remove&r=$VAR{'EDIT_ROW'}\";
}
// --------->
</script>");
	print "$b->{'items'}";
	$a = new makemenu();
	$a->put_item("[]","abook.cgi",tFont);
	$a->put_item("[Ͽ]","abook.cgi?mode=add",pFont);
	$a->put_item("[]","abook.cgi?mode=conf",tFont);
	$a->put_item("[ȥå]","./index.cgi",tFont);
	$a->put_month_day("$THIS_MONTH","$TODAY","$day_of_week");
	$a->{'items'} = "<TABLE border=\"0\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><TBODY><TR>$a->{'items'}</TR></TBODY></TABLE>";
	$a->{'items'} = "<TD width=\"98%\" class=cMenu>$a->{'items'}</td>";
	$a->put_watch;
	$a->put_help("makehelp.cgi?helpfile=habook");

	$a->make_table("100%","0","0","0","");
	$a->{'items'} = "<td>$a->{'items'}</TD>";
	$a->make_table("100%","0","1",0,cBorder,"<FORM name=\"disp\">");
	print "$a->{'items'}<p>";
	&parse_template("$EDIT_HTM", *STDOUT);

	exit;
}
sub clear {
	$VAR{"EDIT_ROW"} = $row;

	
	print "Pragma: no-cache\n";
	print "Content-type: text/html\n\n";
	
	$header = new makemenu();
	$header->make_header("",$cssfile);
	print "$header->{'items'}";
		$b = new makemenu();
	$b->push_html("<SCRIPT LANGUAGE=\"JavaScript\">
<!----------
function confirmcrear()
{
if (confirm(\"ϤƤ򥯥ꥢޤǤ\"))
	location=\"abook.cgi?mode=clear&r=$VAR{'EDIT_ROW'}\";
}
function confirmdel()
{
if (confirm(\"ϿޤˤǤ\"))
	location=\"abook.cgi?mode=remove&r=$VAR{'EDIT_ROW'}\";
}
// --------->
</script>");
	print "$b->{'items'}";

	$a = new makemenu();
	$a->put_item("[]","abook.cgi",tFont);
	$a->put_item("[Ͽ]","abook.cgi?mode=add",tFont);
	$a->put_item("[]","abook.cgi?mode=conf",pFont);
	$a->put_item("[ȥå]","./index.cgi",tFont);
	$a->put_month_day("$THIS_MONTH","$TODAY","$day_of_week");
	$a->{'items'} = "<TABLE border=\"0\" width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><TBODY><TR>$a->{'items'}</TR></TBODY></TABLE>";
	$a->{'items'} = "<TD width=\"98%\" class=cMenu>$a->{'items'}</td>";
	$a->put_watch;
	$a->put_help("makehelp.cgi?helpfile=habook");

	$a->make_table("100%","0","0","0","");
	$a->{'items'} = "<td>$a->{'items'}</td>";
	$a->make_table("100%","0","1",0,cBorder,"<FORM name=\"disp\">");
	print "$a->{'items'}<p>";
	&parse_template("$EDIT_HTM", *STDOUT);

	exit;
}
sub update {
	foreach (@col_label_order) {
		my $col = $form{"c$_"};
		$col =~ s/\n|\r\n/<BR>/g;
		$col =~ s/,/<COMMA>/g;
		if ($col ne "") {
			$ra_LIST->[$row]->[$_] = $col;
		}
	}
	my $col = $form{"c16"};
	if ($col) { $ra_LIST->[$row]->[16] = 1; }
	else { $ra_LIST->[$row]->[16] = 0; }

	$data_db->SetArray ('LIST1', $ra_LIST);
	$data_db->Store ();

	&list;
}
sub remove {
	if ($row ne "") {
		splice (@{$ra_LIST}, $row, 1);
		$data_db->SetArray ('LIST1', $ra_LIST);
		$data_db->Store ();
	}
	&list;
}
